#!/usr/bin/perl 

########################################################################
# Copyright 2007-2011  Open Sense Solutions LLC  http://open-sense.com
#
# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.  You should have received a copy of the GNU General Public License along with this program.  If not, see http://www.gnu.org/licenses/
########################################################################


###########################################
use IO::Socket::INET;
use IO::Select;
use strict;

use Getopt::Long;

die "Usage: $0 [--debug] --server <sip_server> [--port <sip_server_port> ]  --command <sip_command> [--patron_id <patron_id>] [--patron_pw <patron_password>] [--item <item_id>] [--login_id <login> --login_pw <sip_login_password> [--location_code <location code>] ] [--terminal_pw <sip_terminal_password>] [--wait_for_complete_line] [--af_ok] [--phone_for_pw] [--fee_limit <amount> [ --fee_message <message>]]   [--block_field <XY> --block_code <customcode> [--block_message \"<custom message>\"]] [--require_field <XY> --require_code <customcode> [--require_message \"<custom message>\"]] \n" unless @ARGV;

my($result,$server,$port,$command,$patron_id,$patron_pw,$item);
my @blockcode;
my @blockfield;
my @blockmessage;
my @requirecode;
my @requirefield;
my @requiremessage;

#defaults
$port=6001;
my $login_id="default";
my $login_pw="default";
my $terminal_pw="default";
my $location_code="";
my $location_code_string="";
my $patron_id=0;
my $patron_pw=0;
my $wait_for_complete_line=0;
my $phone_for_pw=0;
my $af_ok=0;
my $fee_limit=-1;
my $fee_message="ACCESS DENIED: please see the circulation desk.";
$item=0;
my $debug=0;

#other variable initialization
my $got_response=0;
my $newline="";

#print "ARGS ARE: $server,$port,$command,$patron_id,$patron_pw,$item\n";
$result= GetOptions( "server=s"  => \$server,
	"debug"  => \$debug,
	"phone_for_pw"  => \$phone_for_pw,
	"wait_for_complete_line"  => \$wait_for_complete_line,
	"af_ok"  => \$af_ok,
	"fee_limit=f"  => \$fee_limit,
	"fee_message=s"  => \$fee_message,
	"port=i"  => \$port,
	"block_field=s" => \@blockfield,
	"block_code=s" => \@blockcode,
	"block_message=s" => \@blockmessage,
	"require_field=s" => \@requirefield,
	"require_code=s" => \@requirecode,
	"require_message=s" => \@requiremessage,
	"command=s"  => \$command,
	"patron_id=s"  => \$patron_id,
	"patron_pw=s"  => \$patron_pw,
	"login_id=s"  => \$login_id,
	"login_pw=s"  => \$login_pw,
	"location_code=s"  => \$location_code,
	"terminal_pw=s"  => \$terminal_pw,
	"item=s"  => \$item
 );
#print "ARGS ARE $server,$port,$command,$patron_id,$patron_pw,$item\n";

unless ($command){ print "no command given\n"; exit 0 }

my $remote_host = $server;
#my $remote_host = "localhost";
if ($remote_host =~ /^([ &:#-\@\w.]+)$/) {
	$remote_host = $1; #data is now untainted
} 
my $remote_port = $port;
my $timeout = 10;

my $socket = IO::Socket::INET->new(
                                PeerAddr => $remote_host,
                                PeerPort => $remote_port,
                                Proto    => "tcp");
#   or die "Couldn't connect to $remote_host:$remote_port : $!\n";
unless ($socket) {
	print "Couldn't connect to sip server";
	# rc 2 is for can't connect to server, login may be allowed anyways
	print "\n" if ($debug);
	exit 2;
}

my $sel = new IO::Select( $socket );
#$socket->autoflush(1);
my $date_time = SIPDateTime();
my $institution_id = 'sh';
#my $patron_identifier = zeroFill($patron_id,10);
my $patron_identifier = $patron_id;
my $patron_password = $patron_pw;
my $sequence_number = 0;

##PATRON STATUS
#23 is simple patron status , 63 is more patron information
#23 = patron status, 000 = default lang (001 is english) ,date,summary (blank is just summaries), AO is sh = sheboygan , | = separator after variable fields , AA= patron id, AC=terminal pass, AD= patron pass, AY sequence #, AZ checksum added on the end

#do we need login first?
if ($login_id) {
	if ($location_code) {
		$location_code_string="|CP$location_code";
	} else {
		$location_code_string="";
	}
	my $s2login = '93' . '00' . 'CN' . $login_id . '|' . 'CO' . $login_pw . $location_code_string . '|' . 'AY' . $sequence_number . 'AZ' ;
	my $s2response = SendReceive($s2login);
	print "Received: $s2response\n" if $debug; # DEBUG
	$sequence_number+=1;
	#sc status
	#my $s2login = '99' . '0' . '080' . '2.00' . 'AY0'.'AZ' ;
	#my $s2response = SendReceive($s2login);
	#print "Received: $s2response\n"; # DEBUG
	#$sequence_number+=1;
}

	my %options;
	my $responsecode;
	my $lang;
	my $date;
	my $holdi;
	my $overi;
	my $chargedi;
	my $finei;
	my $recalli;
	my $unavaili;
	my $therest;

if ($command="patroninfo") {
	my $slogin = '63' . '000' . $date_time . '          ' . 'AO' . 'sh' . '|' . 'AA' .        $patron_identifier .  '|' . 'AC' . $terminal_pw . '|' . 'AD' . $patron_password . '|'  . 'AY'.$sequence_number.'AZ' ;

#	my $slogin = '63' . '000' . $date_time . '          ' . 'AO' . 'sh' . '|' . 'AA' . $patron_identifier .  '|' . 'AC' . '3M' . '|' . 'AD' . $patron_password . '|'  . 'AY0AZ' ;
	#my $slogin = '63' . '000' . $date_time . '          ' . 'AO' . 'sh' . '|' . 'AA' . $patron_identifier .  '|' . 'AC' . 'terminalpassword' . '|' . 'AD' . $patron_password . '|'  . 'AY0AZ' ;

	my $sresponse = SendReceive($slogin);
	close($socket);

	print "Received: $sresponse\n" if ($debug) ;# DEBUG
	$_=$sresponse;
	#my ($responsecode,$status,$lang,$date,$holdi,$overi,$chargedi,$finei,$recalli,$unavaili,$therest)=/^(..)(.{14})(...)(.{18})(....)(....)(....)(....)(....)(....)(AO.*)$/;
	($responsecode,$options{'PS0'},$options{'PS1'},$options{'PS2'},$options{'PS3'},$options{'PS4'},$options{'PS5'},$options{'PS6'},$options{'PS7'},$options{'PS8'},$options{'PS9'},$options{'PS10'},$options{'PS11'},$options{'PS12'},$options{'PS13'},$lang,$date,$holdi,$overi,$chargedi,$finei,$recalli,$unavaili,$therest)=/^(..)(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)(.)(...)(.{18})(....)(....)(....)(....)(....)(....)(.*)$/;
	print "\n" if ($debug);
	#print "$responsecode - $status - $lang - $date - $holdi - $overi - $chargedi - $finei - $recalli - $unavaili\n" if ($debug);
	print "$responsecode - $lang - $date - $holdi - $overi - $chargedi - $finei - $recalli - $unavaili\n" if ($debug);
#print " -tr= $therest ";
	$_=$therest;

        my $pspos;
	for ( $pspos=0 ; $pspos < 14 ; $pspos++ ) { 
		print "-  \$options\{PS$pspos} = " if ($debug);
		print $options{"PS$pspos"} if ($debug);
		print "\n" if ($debug);
	}
	


	do {
	#	s/(..)([^\|]+)\|//;
		s/(..)([^\|]+)*\|//;
		$options{$1}=$2;
		print "-  \$options\{$1\} = $options{$1}\n" if ($debug);
		#print " -tr - $_\n";
	} while (/\|/);
	s/^AY(.*)AZ(.*)$//;
	my $sequence=$1;
	my $checksum=$2;
	print "\n - $sequence - $checksum \n\n" if ($debug);
	if ($af_ok) {
		if ($options{'AF'}) {
			unless ( $options{'AF'}=~/Patron status is ok/ ) {
				print "ACCESS DENIED: $options{'AF'}";
				print "\n" if ($debug);
				exit 10
			}
		}
	} else {
		if ($options{'AF'}) {
			if ( $options{'AF'}=~/atron does not exist/ ) {
				print "ACCESS DENIED: invalid barcode or pin";
				print "\n" if ($debug);
				exit 10
			}
		}
	}
	if ($fee_limit != -1) {
        	if ($options{'BV'}) {
			if ( $options{'BV'} > $fee_limit ) {
				print $fee_message;
				print "\n" if ($debug);
				exit 15
			}
		}
	}
	if ($phone_for_pw) {
        	if ($options{'BF'}) {
                	unless ( $options{'BF'}=~/\d\d\d-\d\d\d-$patron_password\b/ ) {
	                        print "ACCESS DENIED: invalid patron password";
				print "\n" if ($debug);
       		                exit 12
			}
       		}
	} else { 
		# CQ is supposed to be the password correct field
		if ($options{'CQ'}) {
			unless ( $options{'CQ'}=~/Y/ ) {
				print "ACCESS DENIED: invalid barcode or pin";
				print "\n" if ($debug);
				exit 14
			}
		}
	}

	for (my $i = 0; $i < @blockfield; $i ++) {
	print "blocking if $blockfield[$i] = $blockcode[$i] , value:  $options{$blockfield[$i]} \n" if ($debug);
	if ($options{$blockfield[$i]}) {
		if ($options{$blockfield[$i]} eq $blockcode[$i]) {
			if ($blockmessage[$i]) {
				print "ACCESS DENIED: $blockmessage[$i]";
			} else {
				print "ACCESS DENIED: CODE $blockfield[$i] = $options{$blockfield[$i]}";
			}
			print "\n" if ($debug);
			exit 11
		}
	}
	}

	for (my $i = 0; $i < @requirefield; $i ++) {
	print "requiring $requirefield[$i] = $requirecode[$i] , value: $options{$requirefield[$i]} \n" if ($debug);
	#if (($options{$requirefield[$i]}) && ($options{$requirefield[$i]} eq $requirecode[$i]))  {
	if ($options{$requirefield[$i]} eq $requirecode[$i])  {
		#print "requirement met\n" if ($debug);
	} else {
		if ($requiremessage[$i]) {
			print "ACCESS DENIED: $requiremessage[$i]";
		} else {
			print "ACCESS DENIED: CODE $requirefield[$i] is not $options{$requirefield[$i]}";
		}	
		print "\n" if ($debug);
		exit 16
	}
	}
}



#don't need to logoff
#my $logoff = '35' . $date_time . 'AO' . $institution_id .  '|AA' .  $patron_identifier . '|AY' . '2' . 'AZ';
#my $response = SendReceive($logoff);
#print "Received: $response\n"; # DEBUG
#my $shutdown = '9920002.00AY' . ++$sequence_number . 'AZ';
#my $response = SendReceive($shutdown);
#print "Received: $response\n"; # DEBUG



#0 default error exit code if we haven't found an error and exited by now
print "PATRON OK";
print "\n" if ($debug);
exit 0;

#####################################################
sub SendReceive  {

        my $message = shift;
        my $line;
        my $message_checksum = Checksum($message);
        print "    Sent: $message$message_checksum\n" if ($debug); # DEBUG

        #print $socket "$message$message_checksum\n";
        print $socket "$message$message_checksum". chr(hex("0D"));

	
	if ($wait_for_complete_line) {
		###################################################################################################
		#was necessary for albany, try this if sip server is problematic and only returning partial data
		###################################################################################################
		$line="";
		while ($sel->can_read($timeout) )  {
			$got_response=1;
			my $response = sysread($socket, $newline, 1024);
			print "DEBUG: read newline as $newline\n" if ($debug);
			$line=$line.$newline;
			#if we have a matching checksum and carriage return we know were complete, don't wait for timeout
			if ($line=~/(.*AY\d+AZ)(....)(\r)/) 	{
				print "data so far is ".$1."\n" if ($debug);
				print "checksum should be ".Checksum($1)."\n" if ($debug);
				if (Checksum($1) eq $2 ) {
					#print "matched checksum, line is complete! note: end of line was begin";
					#foreach $byte (split //, $3) {
					#    print ord($byte);
					#}
					#print "end\n\n";
					last;
				}
			}

        	} 

		unless ($got_response) { undef $line; }

		###################################################################################################

	} else {
        	if ($sel->can_read($timeout) )  {
                	my $response = sysread($socket, $line, 1024);
	        } else { 
			undef $line; 
		}
	}

	#strip any newlines
	$line=~ s/\n/ /g;

        return $line;
}
#####################################################
sub Checksum  {

        my $message = shift;
        $message = $message . "\0";
        my $sum = 0;
        my $i;
        for($i = 0; $i < length($message); $i++)  {

                $sum += ord(substr($message, $i, 1));
        }
        my $checksum = ($sum ^ 0xFFFF) + 1;
        return sprintf("%4.4X", $checksum);
}
############################################################################
################
sub SIPDateTime  {

        # Convert date/time returned by localtime to SIP date/time string (YYYYMMDDZZZZHHMMSS)

        my($sec, $min, $hour, $mday, $mon, $year) = localtime( time );
        $year += 1900;
        my $four_spaces = '    ';
        $mon++; # Month returned as 0 - 11, so increment to get the correct number.
        return sprintf("$year%02d%02d%02d$four_spaces%02d%02d", $mon, $mday, $hour, $min, $sec);
}

############################################################################
sub zeroFill {
    my($temp) = shift;
    my($len)  = shift;
    my($diff) = $len - length($temp);
    return($temp) if $diff <= 0;
    return(('0' x $diff) . $temp);
}


################

