#!/usr/bin/perl
#use strict;
use Getopt::Long;

#NEEDED PACKAGES
#libxml-simple-perl

unless (@ARGV) {
print "Usage: $ --server <server> --serverpath <serverpath> --patron_id <patron_id> --patron_pw <patron_password>" ;
exit(1);
}

my($server,$serverpath,$patron_id,$patron_pw);
my $debug=0;

$result= GetOptions( "server=s" => \$server,
         "serverpath=s" => \$serverpath,
         "patron_id=s" => \$patron_id,
         "patron_pw=s" => \$patron_pw,
         );

unless ($server){print "no server given\nUsage: xml_authenticator.pl --server <server> --serverpath <serverpath> --patron_id <patron_id> --patron_pw <patron_password>\n\n"; exit 2}
unless ($serverpath){print "no server path given\nUsage: xml_authenticator.pl --server <server> --serverpath <serverpath> --patron_id <patron_id> --patron_pw <patron_password>\n\n"; exit 2}
unless ($patron_id){print "no patron id given\nUsage: xml_authenticator.pl --server <server> --serverpath <serverpath> --patron_id <patron_id> --patron_pw <patron_password>\n\n"; exit 2}
unless ($patron_pw){print "no patron password given\nUsage: xml_authenticator.pl --server <server> --serverpath <serverpath> --patron_id <patron_id> --patron_pw <patron_password>\n\n"; exit 2}
         
print "Using Server:          $server\n" if ($debug); # DEBUG;
print "Using Server Path:     $serverpath\n" if ($debug); # DEBUG;
print "Using Patron ID:       $patron_id\nUsing Patron Password: $patron_pw\n" if ($debug); # DEBUG;

my ($account_status, $error_message) = xml_authenticator($server,$serverpath,$patron_id,$patron_pw);

print "Account Status:        $account_status\nError Message:         $error_message\n" if ($debug); # DEBUG


if ($account_status == 0) {

   #if ($account_status == 0) {
   #     print "ACCESS DENIED: $error_message";
   #     exit 10
   #}

   print "ACCESS DENIED: $error_message";
   exit 10
}

print "PATRON OK";
exit 0;


###################################
sub xml_authenticator () {

use LWP;
use XML::Parser;
use XML::Simple;
use Data::Dumper;

# Create a user agent object
my $ua = LWP::UserAgent->new;
$ua->agent("PatronAuthenticator(c)AlbanyPublicLibrary/Version 1.0 ");
# Create a request
my $request    = "http://$server/$serverpath?LibraryCard=$patron_id&PIN=$patron_pw";
#my $request    = "http://$server/auth/XMLAuth.php?LibraryCard=$patron_id&PIN=$patron_pw";
my $req = HTTP::Request->new(POST => $request);
$req->content_type('application/x-www-form-urlencoded');
$req->content('query=libwww-perl&mode=dist');
# Pass request to the user agent and get a response back
my $res = $ua->request($req);
my $auth_response;
# Check the outcome of the response
if ($res->is_success)
  {
  #Get XML Page
  $tmp = $res->content;
  #Try parsing with simple xml library
  $auth_response = XMLin($tmp);
  my $dump_result if ($debug); # DEBUG
  $dump_result = Dumper($auth_response) if ($debug); # DEBUG
  print "XML Dump:\n$dump_result\n\n" if ($debug); # DEBUG
  # Get data array structure
  $account_status = $auth_response->{Status};
  $error_message = $auth_response->{ErrorDetails};
  }
  else
  {
  $account_status = 0;
  $error_message = "Sorry, the authentication server is not responding";
  }
return ("$account_status", "$error_message");
}
###################################

